//
// Teams.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Teams: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var teamKeyNumeric: Double?
    public var teamLeadKeyNumeric: Double?
    public var originatingSystemID: Double?
    public var originatingSystemKey: String?
    public var originatingSystemName: String?
    public var sourceSystemID: Double?
    public var sourceSystemKey: String?
    public var sourceSystemName: String?
    public var teamAddress1: String?
    public var teamAddress2: String?
    public var teamCarrierRoute: String?
    public var teamCity: String?
    public var teamDescription: String?
    public var teamDirectPhone: String?
    public var teamEmail: String?
    public var teamFax: String?
    public var teamKey: String?
    public var teamLeadKey: String?
    public var teamLeadLoginId: String?
    public var teamLeadMlsId: String?
    public var teamLeadNationalAssociationId: String?
    public var teamLeadStateLicense: String?
    public var teamMobilePhone: String?
    public var teamName: String?
    public var teamOfficePhone: String?
    public var teamOfficePhoneExt: String?
    public var teamPostalCode: String?
    public var teamPostalCodePlus4: String?
    public var teamPreferredPhone: String?
    public var teamPreferredPhoneExt: String?
    public var teamTollFreePhone: String?
    public var teamVoiceMail: String?
    public var teamVoiceMailExt: String?
    public var socialMediaType: String?
    public var teamCountry: String?
    public var teamCountyOrParish: String?
    public var teamLeadStateLicenseState: String?
    public var teamStateOrProvince: String?
    public var teamStatus: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var teamLead: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?
    public var buyerTeamProperties: Property?
    public var listTeamProperties: Property?

    public init(id: Int? = nil, teamKeyNumeric: Double? = nil, teamLeadKeyNumeric: Double? = nil, originatingSystemID: Double? = nil, originatingSystemKey: String? = nil, originatingSystemName: String? = nil, sourceSystemID: Double? = nil, sourceSystemKey: String? = nil, sourceSystemName: String? = nil, teamAddress1: String? = nil, teamAddress2: String? = nil, teamCarrierRoute: String? = nil, teamCity: String? = nil, teamDescription: String? = nil, teamDirectPhone: String? = nil, teamEmail: String? = nil, teamFax: String? = nil, teamKey: String? = nil, teamLeadKey: String? = nil, teamLeadLoginId: String? = nil, teamLeadMlsId: String? = nil, teamLeadNationalAssociationId: String? = nil, teamLeadStateLicense: String? = nil, teamMobilePhone: String? = nil, teamName: String? = nil, teamOfficePhone: String? = nil, teamOfficePhoneExt: String? = nil, teamPostalCode: String? = nil, teamPostalCodePlus4: String? = nil, teamPreferredPhone: String? = nil, teamPreferredPhoneExt: String? = nil, teamTollFreePhone: String? = nil, teamVoiceMail: String? = nil, teamVoiceMailExt: String? = nil, socialMediaType: String? = nil, teamCountry: String? = nil, teamCountyOrParish: String? = nil, teamLeadStateLicenseState: String? = nil, teamStateOrProvince: String? = nil, teamStatus: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, teamLead: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil, buyerTeamProperties: Property? = nil, listTeamProperties: Property? = nil) {
        self.id = id
        self.teamKeyNumeric = teamKeyNumeric
        self.teamLeadKeyNumeric = teamLeadKeyNumeric
        self.originatingSystemID = originatingSystemID
        self.originatingSystemKey = originatingSystemKey
        self.originatingSystemName = originatingSystemName
        self.sourceSystemID = sourceSystemID
        self.sourceSystemKey = sourceSystemKey
        self.sourceSystemName = sourceSystemName
        self.teamAddress1 = teamAddress1
        self.teamAddress2 = teamAddress2
        self.teamCarrierRoute = teamCarrierRoute
        self.teamCity = teamCity
        self.teamDescription = teamDescription
        self.teamDirectPhone = teamDirectPhone
        self.teamEmail = teamEmail
        self.teamFax = teamFax
        self.teamKey = teamKey
        self.teamLeadKey = teamLeadKey
        self.teamLeadLoginId = teamLeadLoginId
        self.teamLeadMlsId = teamLeadMlsId
        self.teamLeadNationalAssociationId = teamLeadNationalAssociationId
        self.teamLeadStateLicense = teamLeadStateLicense
        self.teamMobilePhone = teamMobilePhone
        self.teamName = teamName
        self.teamOfficePhone = teamOfficePhone
        self.teamOfficePhoneExt = teamOfficePhoneExt
        self.teamPostalCode = teamPostalCode
        self.teamPostalCodePlus4 = teamPostalCodePlus4
        self.teamPreferredPhone = teamPreferredPhone
        self.teamPreferredPhoneExt = teamPreferredPhoneExt
        self.teamTollFreePhone = teamTollFreePhone
        self.teamVoiceMail = teamVoiceMail
        self.teamVoiceMailExt = teamVoiceMailExt
        self.socialMediaType = socialMediaType
        self.teamCountry = teamCountry
        self.teamCountyOrParish = teamCountyOrParish
        self.teamLeadStateLicenseState = teamLeadStateLicenseState
        self.teamStateOrProvince = teamStateOrProvince
        self.teamStatus = teamStatus
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.teamLead = teamLead
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
        self.buyerTeamProperties = buyerTeamProperties
        self.listTeamProperties = listTeamProperties
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case teamKeyNumeric = "TeamKeyNumeric"
        case teamLeadKeyNumeric = "TeamLeadKeyNumeric"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemKey = "OriginatingSystemKey"
        case originatingSystemName = "OriginatingSystemName"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemKey = "SourceSystemKey"
        case sourceSystemName = "SourceSystemName"
        case teamAddress1 = "TeamAddress1"
        case teamAddress2 = "TeamAddress2"
        case teamCarrierRoute = "TeamCarrierRoute"
        case teamCity = "TeamCity"
        case teamDescription = "TeamDescription"
        case teamDirectPhone = "TeamDirectPhone"
        case teamEmail = "TeamEmail"
        case teamFax = "TeamFax"
        case teamKey = "TeamKey"
        case teamLeadKey = "TeamLeadKey"
        case teamLeadLoginId = "TeamLeadLoginId"
        case teamLeadMlsId = "TeamLeadMlsId"
        case teamLeadNationalAssociationId = "TeamLeadNationalAssociationId"
        case teamLeadStateLicense = "TeamLeadStateLicense"
        case teamMobilePhone = "TeamMobilePhone"
        case teamName = "TeamName"
        case teamOfficePhone = "TeamOfficePhone"
        case teamOfficePhoneExt = "TeamOfficePhoneExt"
        case teamPostalCode = "TeamPostalCode"
        case teamPostalCodePlus4 = "TeamPostalCodePlus4"
        case teamPreferredPhone = "TeamPreferredPhone"
        case teamPreferredPhoneExt = "TeamPreferredPhoneExt"
        case teamTollFreePhone = "TeamTollFreePhone"
        case teamVoiceMail = "TeamVoiceMail"
        case teamVoiceMailExt = "TeamVoiceMailExt"
        case socialMediaType = "SocialMediaType"
        case teamCountry = "TeamCountry"
        case teamCountyOrParish = "TeamCountyOrParish"
        case teamLeadStateLicenseState = "TeamLeadStateLicenseState"
        case teamStateOrProvince = "TeamStateOrProvince"
        case teamStatus = "TeamStatus"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case teamLead = "TeamLead"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
        case buyerTeamProperties = "BuyerTeamProperties"
        case listTeamProperties = "ListTeamProperties"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(teamKeyNumeric, forKey: .teamKeyNumeric)
        try container.encodeIfPresent(teamLeadKeyNumeric, forKey: .teamLeadKeyNumeric)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemKey, forKey: .originatingSystemKey)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemKey, forKey: .sourceSystemKey)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(teamAddress1, forKey: .teamAddress1)
        try container.encodeIfPresent(teamAddress2, forKey: .teamAddress2)
        try container.encodeIfPresent(teamCarrierRoute, forKey: .teamCarrierRoute)
        try container.encodeIfPresent(teamCity, forKey: .teamCity)
        try container.encodeIfPresent(teamDescription, forKey: .teamDescription)
        try container.encodeIfPresent(teamDirectPhone, forKey: .teamDirectPhone)
        try container.encodeIfPresent(teamEmail, forKey: .teamEmail)
        try container.encodeIfPresent(teamFax, forKey: .teamFax)
        try container.encodeIfPresent(teamKey, forKey: .teamKey)
        try container.encodeIfPresent(teamLeadKey, forKey: .teamLeadKey)
        try container.encodeIfPresent(teamLeadLoginId, forKey: .teamLeadLoginId)
        try container.encodeIfPresent(teamLeadMlsId, forKey: .teamLeadMlsId)
        try container.encodeIfPresent(teamLeadNationalAssociationId, forKey: .teamLeadNationalAssociationId)
        try container.encodeIfPresent(teamLeadStateLicense, forKey: .teamLeadStateLicense)
        try container.encodeIfPresent(teamMobilePhone, forKey: .teamMobilePhone)
        try container.encodeIfPresent(teamName, forKey: .teamName)
        try container.encodeIfPresent(teamOfficePhone, forKey: .teamOfficePhone)
        try container.encodeIfPresent(teamOfficePhoneExt, forKey: .teamOfficePhoneExt)
        try container.encodeIfPresent(teamPostalCode, forKey: .teamPostalCode)
        try container.encodeIfPresent(teamPostalCodePlus4, forKey: .teamPostalCodePlus4)
        try container.encodeIfPresent(teamPreferredPhone, forKey: .teamPreferredPhone)
        try container.encodeIfPresent(teamPreferredPhoneExt, forKey: .teamPreferredPhoneExt)
        try container.encodeIfPresent(teamTollFreePhone, forKey: .teamTollFreePhone)
        try container.encodeIfPresent(teamVoiceMail, forKey: .teamVoiceMail)
        try container.encodeIfPresent(teamVoiceMailExt, forKey: .teamVoiceMailExt)
        try container.encodeIfPresent(socialMediaType, forKey: .socialMediaType)
        try container.encodeIfPresent(teamCountry, forKey: .teamCountry)
        try container.encodeIfPresent(teamCountyOrParish, forKey: .teamCountyOrParish)
        try container.encodeIfPresent(teamLeadStateLicenseState, forKey: .teamLeadStateLicenseState)
        try container.encodeIfPresent(teamStateOrProvince, forKey: .teamStateOrProvince)
        try container.encodeIfPresent(teamStatus, forKey: .teamStatus)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(teamLead, forKey: .teamLead)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
        try container.encodeIfPresent(buyerTeamProperties, forKey: .buyerTeamProperties)
        try container.encodeIfPresent(listTeamProperties, forKey: .listTeamProperties)
    }
}

